// This class was created by JaTiTV.

package net.t2code.t2codelib.SPIGOT.system.config.languages;


import net.t2code.t2codelib.T2CLanguageEnum;
import net.t2code.t2codelib.T2CconfigItemLanguages;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2CconfigWriterLanguage;
import net.t2code.t2codelib.SPIGOT.system.T2CodeLibMain;
import net.t2code.t2codelib.SPIGOT.system.config.config.T2CLibConfig;
import net.t2code.t2codelib.Util;

import java.util.*;

public class Languages {

    public enum VALUES implements T2CconfigItemLanguages {


        vaultNotSetUp("plugin.vaultNotSetUp",
                null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.english, "[prefix] &4Vault / Economy not set up!");
                    put(T2CLanguageEnum.german, "[prefix] &4Vault / Economy nicht eingerichtet!");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.english, List.of());
                    put(T2CLanguageEnum.german, List.of());
                }}),

        votingPluginNotSetUp("plugin.votingPluginNotSetUp",
                null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.english, "[prefix] &4VotingPlugin is not present on the server!");
                    put(T2CLanguageEnum.german, "[prefix] &4VotingPlugin ist auf dem Server nicht vorhanden!");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.english, List.of());
                    put(T2CLanguageEnum.german, List.of());
                }}),
        soundNotFound("plugin.soundNotFound",
                null,
                new HashMap<>() {{
                    put(T2CLanguageEnum.english, "[prefix] &4The sound &6[sound] &4was not found! Please check the settings.");
                    put(T2CLanguageEnum.german, "[prefix] &4Der Sound &6[sound] &4wurde nicht gefunden! Bitte [ue]berpr[ue]fe die Einstellungen.");
                }},
                new HashMap<>() {{
                    put(T2CLanguageEnum.english, List.of());
                    put(T2CLanguageEnum.german, List.of());
                }}),

        ;

        private final String path;
        private Object value;
        private final HashMap<T2CLanguageEnum, String> lang;
        private final HashMap<T2CLanguageEnum, List<String>> comments;

        VALUES(String path, Object value, HashMap<T2CLanguageEnum, String> lang, HashMap<T2CLanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.lang = lang;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            if (value == null) {
                return lang.get(T2CLanguageEnum.english);
            }
            return value;
        }

        @Override
        public HashMap<T2CLanguageEnum, String> getLanguage() {
            return lang;
        }

        @Override
        public HashMap<T2CLanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void set() {
        T2CconfigWriterLanguage.createConfig(T2CodeLibMain.getPath(), VALUES.values(), T2CLibConfig.VALUES.language.getValue().toString(), Util.getConfigLogo());

    }
}